#!/usr/bin/perl

$ERROR = 300 * 300 / 400; # 5%
$| = 1;

# $stroke_num
# $point_num
# $point_x
# $point_y

$nos = 0;
while (<>) {
    if (/^D (\d+) (\d+)/) {
	@point = (int($1 * 300 / 160)."x".int($2 * 300 / 160));
	next;
    }
    if (/^M (\d+) (\d+)/) {
	push(@point, int($1 * 300 / 160)."x".int($2 * 300 / 160));
	next;
    }
    if (/^U (\d+) (\d+)/) {
	@vertex = get_vertex(@point);
	unshift(@vertex, $point[0]);
	for($i = 0; $i < @vertex; $i++) {
	    $vertex[$i] =~ /^(\d+)x(\d+)/;
	    $x[$nos][$i] = $1;
	    $y[$nos][$i] = $2;
	}	    
	$nop[$nos] = @vertex;
	$nos++;
	next;
    }
    if (/^$/) {
	if ($nos == 0) { next; }

	print ":$nos\n";
	for ($i = 0; $i < $nos; $i++) {
	    print "$nop[$i]";
	    for ($j = 0; $j < $nop[$i]; $j++) {
		print " ($x[$i][$j] $y[$i][$j])";
	    }
	    print "\n";
	}
	print "\n";
	$nos = 0;
	next;
    }
}

sub get_vertex {
    my(@point) = @_;
    my($dist, $most_node);
    my(@rv);
    my(@front_p, @rear_p, @front_v, @rear_v);

    if (@point == 0) {
	return ();
    } elsif (@point > 2) {
	($dist, $most_node) = get_distance(@point);
    } else {
	($dist, $most_node) = (0, 0);
    }

    if ($dist > $ERROR) {
	@rear_p  = splice(@point, $most_node);
	@front_p = (@point, @rear_p[0]);

	@front_v = get_vertex(@front_p);
	@rear_v  = get_vertex(@rear_p);
	@rv = (@front_v, @rear_v);
    } else {
	push(@rv, $point[$#point]);
    }
    return @rv;
}

sub get_distance {
    my(@point) = @_;
    my(@x, @y, $i);
    my($a, $b, $c);
    my($dist, $max) = (0, 0);
    my($most_node);

    foreach (@point) {
	/(\d+)x(\d+)/;
	push(@x, $1);
	push(@y, $2);
    }
    $a = $x[$#x] - $x[0];
    $b = $y[$#y] - $y[0];
    $c = $y[$#y] * $x[0] - $x[$#x] * $y[0];

    for ($i = 1; $i < $#x; $i++) {
	$dist = abs(($a * $y[$i]) - ($b * $x[$i]) + $c);
	if ($dist > $max) {
	    $max = $dist;
	    $most_node = $i;
	}
    }
    return ($max * $max / ($a*$a + $b*$b), $most_node);
}
