#!/usr/bin/perl
# $Id: tomoe.pl,v 1.4 2000/05/19 13:15:39 komatsu Exp $
#  ./tomoe.pl  26.35s user 0.26s system 96% cpu 27.666 total
#$LIMIT_LENGTH = (300 * 0.2) * (300 * 0.2); # 20 % 
#$LIMIT_LENGTH = (300 * 0.3) * (300 * 0.3); # 30 % 
$LIMIT_LENGTH = (300 * 0.25) * (300 * 0.25); # 25 % 

# point_*  : ѿ.
# vertex_* :  (ǧ) ѿ.

sub load_data {
    my ($i, $j, $k) = (0, 0, 0);
    my (@v, @w);
    open(DATA, "./hiragana.tdic");

    while(<DATA>) {
	# ʸ
	chomp;
	$letter[$i] = $_;
    
	# 
	$_ = <DATA>;
	$_ =~ /:(\d+)/;
	$line_num[$i] = $1;

	# ȥ
	$j = 0;
	while(($_ = <DATA>) !~ /^ *$/) {
	    $k = 0;
	    chomp;
	    $_ =~ s/^(\d+) //;
	    $point_num[$i][$j] = $1;
	    while($_) {
		$_ =~ s/^\((\d+) (\d+)\) *//;
		$point_x[$i][$j][$k] = $1;
		$point_y[$i][$j][$k] = $2;
		$v[$k] = $1;
		$w[$k] = $2;
		if ($k > 0) {
		    $ppa[$i][$j][$k-1] = $v[$k] - $v[$k-1];
		    $ppb[$i][$j][$k-1] = $w[$k] - $w[$k-1];
		    $ppc[$i][$j][$k-1] = $w[$k] * $v[$k-1] - $v[$k] * $w[$k-1];
		    $ppd[$i][$j][$k-1] =
		      sqrt($ppa[$i][$j][$k-1] * $ppa[$i][$j][$k-1] +
			   $ppb[$i][$j][$k-1] * $ppb[$i][$j][$k-1]);
		    $ppe[$i][$j][$k-1] =
		      $ppa[$i][$j][$k-1] * $v[$n]
			+ $ppb[$i][$j][$k-1] * $v[$n];
		}
		$k++;
	    }
	    $j++;
	}
	$i++;
    }
    $num_of_letters = $i;
    close(DATA);
}

sub get_stroke {
    my ($j, $k);

    # 
    while (<>) {
	print;
	if (/EOF/) {
	    exit;
	}
	if (/:(\d+)/) {
	    $stroke_num = $1;
	    last;
	}
    }

    # ȥ
    for($j = 0; $j < $stroke_num; $j++) {
	$_ = <>;
	print;
	$k = 0;
	chomp;
	$_ =~ s/^(\d+) //;
	$vertex_num[$j] = $1;
	while($_) {
	    $_ =~ s/^\((\d+) (\d+)\) ?//;
	    $vertex_x[$j][$k] = $1;
	    $vertex_y[$j][$k] = $2;
	    $k++;
	}
    }
}

sub match_char {
    my ($i, $j, $k);
    my (@a);
    my (@cand, @verbose_cand);
    my ($pre_char, %stroke);
    for ($i = 0; $i < $num_of_letters; $i++) {
	if ($stroke_num <= $line_num[$i]) {
	    push(@cand, "$i/");
	}
    }

    for($i = 0; $i < $stroke_num; $i++) {
	@verbose_cand = get_candidates($i, @cand);
	$pre_char  = "";
	%stroke    = ();
	@cand = ();
	print "( ";
	foreach $j (@verbose_cand) {
	    ($k, $a) = split(/\//, $j);
	    if($pre_char ne $k ||
	       $stroke{join(':', sort(split(/:/, $a)))} == 0) {
		$stroke{join(':', sort(split(/:/, $a)))} = 1;
		# NG: Ŭɮ礬¸ʤ
		print "$letter[$k]|$a ";
		push(@cand, $j);
	    }
	    $pre_char = $k;
	}
	print ")\n";
    }
    return @cand;
}

sub get_candidates {
    my ($s) = shift;
    my (@candidates) = @_;
    my (@a, @b, @c, @d);
    my ($cand, $char);
    my ($i, $j, $k, $l, $min);
    my (@x, @y, $fx, $fy, $lx, $ly);
    my (@v, @w, $fv, $fw, $lv, $lw);
    my (@v_angle, @p_angle);
    my ($dx, $dy, $dv, $dw);
    my (@rtn_cand) = ();
    my ($nop);
    my ($nov) = $vertex_num[$s];
    my (@cache) = ();

    # ȥκɸ: ħȤεΥ뤿˻Ȥ.
    for ($n = 0; $n < $nov; $n++) {
	$x[$n] = $vertex_x[$s][$n];
	$y[$n] = $vertex_y[$s][$n];
    }
    # ȥγ
    for ($n = 0; $n < $nov -1; $n++) {
	$v_angle[$n] = atan2($y[$n+1] - $y[$n], $x[$n+1] - $x[$n]);
    }
    $v_angle[$nov -1] = $v_angle[$nov -2];
    $fx = $x[0];
    $fy = $y[0];
    $lx = $x[$nov -1];
    $ly = $y[$nov -1];

    for ($n = 0; $n < $nov -1; $n++) {
	$va[$n] = $x[$n +1] - $x[$n];
	$vb[$n] = $y[$n +1] - $y[$n];
	$vc[$n] = $y[$n +1] * $x[$n] - $x[$n +1] * $y[$n];
	$vd[$n] = sqrt($va[$n] * $va[$n] + $vb[$n] * $vb[$n]);
	$ve[$n] = $va[$n] * $x[$n] + $vb[$n] * $y[$n];
    }

    foreach $i (@candidates) {
	($cand, $adapted) = split(/\//, $i);
	$char = $letter[$cand];
      MATCHING: 
	for ($j = 0; $j < $line_num[$cand]; $j++) {
	    # ޥå󥰺ѤߤΤΤϽ
	    if ("$adapted:" =~ /:$j:/) { next MATCHING; }

	    # åξȤ
	    if ($cache[$cand][$j] == 1) {
		push(@rtn_cand, "$cand/$adapted:$j");
		last;
	    } elsif ($cache[$cand][$j] == -1) {
		next MATCHING;
	    }
	    $cache[$cand][$j] = -1;

	    debug($char, ($j+1)."");
	    # κɸ: ȥħȤεΥ뤿˻Ȥ.
	    $nop = $point_num[$cand][$j];
# 	    for ($n = 0; $n < $nop; $n++) {
# 		$v[$n] = $point_x[$cand][$j][$n];
# 		$w[$n] = $point_y[$cand][$j][$n];
# 	    }
	    @v = @{$point_x[$cand][$j]};
	    @w = @{$point_y[$cand][$j]};

# 	    for ($n = 0; $n < $nop -1; $n++) {
# 		$pa[$n] = $v[$n +1] - $v[$n];
# 		$pb[$n] = $w[$n +1] - $w[$n];
# 		$pc[$n] = $w[$n +1] * $v[$n] - $v[$n +1] * $w[$n];
# 		$pd[$n] = sqrt($pa[$n] * $pa[$n] + $pb[$n] * $pb[$n]);
# 		$pe[$n] = $pa[$n] * $v[$n] + $pb[$n] * $v[$n];
# 	    }
	    @pa = @{$ppa[$cand][$j]};
	    @pb = @{$ppb[$cand][$j]};
	    @pc = @{$ppc[$cand][$j]};
	    @pd = @{$ppd[$cand][$j]};
	    @pe = @{$ppe[$cand][$j]};

	    # ȤεΥ, ħο
	    $fv = $v[0];
	    $fw = $w[0];
	    $lv = $v[$nop -1];
	    $lw = $w[$nop -1];
	    debug($char, "ħ $nop : ȥħ $nov");
	    if (sq_len(($fx - $fv), ($fy - $fw)) > $LIMIT_LENGTH ||
		sq_len(($lx - $lv), ($ly - $lw)) > $LIMIT_LENGTH ||
		abs($nop - $nov) > 3) {
		debug($char, "ȤεΥ, ħο\n".
		     "\tεΥ ".sq_len(($fx - $fv), ($fy - $fw))."\n".
		     "\tεΥ ".sq_len(($lx - $lv), ($ly - $lw))."\n");
		next MATCHING;
	    }

	    # γ % 45  (PI/4) 
	    $dx = $x[1] - $fx;
	    $dy = $y[1] - $fy;
	    $dv = $v[1] - $fv;
	    $dw = $w[1] - $fw;
	    if (sq_len($dx, $dy) > $LIMIT_LENGTH &&
		sq_len($dv, $dw) > $LIMIT_LENGTH &&
		abs(atan2($dy, $dx) - atan2($dw, $dv)) > 3.14 / 4) {
		debug($char, "γ % 45  (PI/4) ");
		next MATCHING;
	    }

	    # γ٤. (γѤ˺Ǹ˰ɲ)
	    for ($k = 0; $k < $nop -1; $k++) {
		$p_angle[$k] = atan2($w[$k+1] - $w[$k], $v[$k+1] - $v[$k]);
	    }
	    $p_angle[$nop -1] = $p_angle[$nop -2];

	    # ħεΥȳ: (ʸ򼭽)
	    $m = 0;
	    if (sq_len($x[$nov -1] - $x[$nov -2], $y[$nov -1] - $y[$nov -2])
		< $LIMIT_LENGTH) {
		debug($char, "֤Ϥ͡פȤߤʤ.");
		$loop = $nov - 2;
	    } else {
		$loop = $nov - 1;
	    }
	    for ($k = 1; $k < $loop; $k++) {
		for ($l = $m; $l < $nop; $l++) {
		    if (sq_len($x[$k]-$v[$l], $y[$k]-$w[$l]) < $LIMIT_LENGTH &&
			abs($v_angle[$k] - $p_angle[$l]) < 3.14 * 0.5) {
			$m = $l;
			debug($char, " $l == ȥ $k"); 
			last;
		    } else {
			# ħʬȤεΥ.
			$rx = $pa[$l] * $x[$k] + $pb[$l] * $y[$k] - $pe[$l];
			if ($l < $nop -1 &&
			    0 <= $rx && $rx <= $pd[$l] * $pd[$l] &&
			    $pa[$l] * $y[$k] - $pb[$l] * $x[$k] - $pc[$l] <
			    $LIMIT_LENGTH * $pd[$l] &&
			    abs($v_angle[$k] - $p_angle[$l]) < 3.14 * 0.5) {
			    $m = $l;
			    debug($char, " $l == ȥ $k"); 
			    last;
			} else {
			    debug($char, 
			      "ħ /  $l : ȥ $k \n".
			      "\t  ".($p_angle[$l] * 180 / 3.14).
			      " : ".($v_angle[$k] * 180 / 3.14)."\n".
			      "\tΥ  ".sq_len($v[$l]-$x[$k], $w[$l]-$y[$k]).
			      " : $LIMIT_LENGTH");
			}
		    }
		}
		if ($l >= $nop) { 
		    debug($char, 
			  "ħεΥȳ: (ʸ򼭽)"); 
		    next MATCHING;
		}
	    }

	    # ħεΥȳ: (ʸ)
	    # NG: 2 ʬ줹٤
	    $m = 0;
	    if (sq_len($v[$nop -1] - $v[$nop -2], $w[$nop -1] - $w[$nop -2])
		< $LIMIT_LENGTH) {
		debug($char, "֤Ϥ͡פȤߤʤ.");
		$loop = $nop - 2;
	    } else {
		$loop = $nop - 1;
	    }
	    for ($k = 1; $k < $loop -1; $k++) {
		for ($l = $m; $l < $nov; $l++) {
		    if (sq_len($v[$k]-$x[$l], $w[$k]-$y[$l]) < $LIMIT_LENGTH &&
			abs($v_angle[$l] - $p_angle[$k]) < 3.14 * 0.5) {
			$m = $l;
			debug($char, " $k == ȥ $l"); 
			last;
		    } else {
			# ħʬȤεΥ.
			$rx = $va[$l] * $v[$k] + $vb[$l] * $w[$k] - $ve[$l];
			if ($l < $nov -1 &&
			    0 <= $rx && $rx <= $vd[$l] * $vd[$l] &&
			    $va[$l] * $w[$k] - $vb[$l] * $v[$k] - $vc[$l] <
			    $LIMIT_LENGTH * $vd[$l] &&
			    abs($v_angle[$l] - $p_angle[$k]) < 3.14 * 0.5) {
			    $m = $l;
			    debug($char, " $k == ȥ $l"); 
			    last;
			} else {
			    debug($char, 
			      "ħ /  $k : ȥ $l \n".
			      "\t  ".($p_angle[$k] * 180 / 3.14).
			      " : ".($v_angle[$l] * 180 / 3.14)."\n".
			      "\tΥ  ".sq_len($v[$k]-$x[$l], $w[$k]-$y[$l]).
			      " : $LIMIT_LENGTH");
			}
		    }
		}
		if ($l >= $nov) {
		    debug($char, 
			  "ħεΥȳ: (ʸ)");
		    next MATCHING;
		}
	    }

	    # NG: ̤ͥʤ
	    $cache[$cand][$j] = 1;
	    push(@rtn_cand, "$cand/$adapted:$j");
	}
    }
    return @rtn_cand;
}

sub sq_len {
    my ($x, $y) = @_;
    return $x * $x + $y * $y;
}

if ($ARGV[0] eq '-d' && $ARGV[1]) {
    $DEBUG = 1;
    $CHAR  = $ARGV[1];
    shift @ARGV;
    shift @ARGV;
}
load_data();

while(1) {
    get_stroke();
#    set_dummy();
    @cand = match_char();
    $pre_char = -1;
    @matched = ();
  LOOP:
    foreach $i (@cand) {
	$i =~ /^(\d+)\/(.*)$/;
	$char = $1;

	if ($line_num[$1] - $stroke_num > 2) { # 3 ʾ
	    $pj = 100;
	    foreach $j (split(/:/, substr($2, 1))) {
		if ($j - $pj > 2) { # 3 ʾΥƤ out
		    $pre_char = $char;
		    next LOOP;
		}
		$pj = $j;
	    }
	}
	if ($pre_char != $char) {
	    $matched[$line_num[$1]] .= ":$char";
	}
	$pre_char = $char;
    }
    foreach $i (@matched) {
	foreach $j (split(/:/, substr($i, 1))) {
	    print "$letter[$j] ";
	}
    }
    print "\n\n";
}

sub disp_data {
    for ($i = 0; $i < $num_of_letters; $i++) {
	print "ʸ: $letter[$i]\n";
	print ": $line_num[$i]\n";
	for ($j = 0; $j < $line_num[$i]; $j++) {
	    print "$j: ";
	    for ($k = 0; $k < $point_num[$i][$j]; $k++) {
		print "($point_x[$i][$j][$k], $point_y[$i][$j][$k]) ";
	    }
	    print "\n";
	}
	print "\n";
    }
}    

sub set_dummy { # ֤פΥǡ.
    $stroke_num = 2;

    $vertex_num[0] = 4;
    $vertex_x[0][0] = 54;    $vertex_y[0][0] = 66;
    $vertex_x[0][1] = 44;    $vertex_y[0][1] = 214;
    $vertex_x[0][2] = 72;    $vertex_y[0][2] = 279;
    $vertex_x[0][3] = 97;    $vertex_y[0][3] = 252;
		                              
    $vertex_num[1] = 2;
    $vertex_x[1][0] = 249;    $vertex_y[1][0] = 73;
    $vertex_x[1][1] = 230;    $vertex_y[1][1] = 237;
}

sub debug {
    my($char, $message) = @_;
    if ($DEBUG) {
	if ($CHAR eq $char) {
	    print "$char: $message\n";
	}
    }
}
